package velha;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class ServerInfo extends JFrame {
	private JList list;
	
	public ServerInfo( String[] servers ){
		super( "Info do Servidor" );
		JPanel panel = new JPanel();
		this.getContentPane().add( panel );
		panel.setLayout( new BorderLayout() );
		list = new JList( servers );
		list.setVisibleRowCount( 5 );
		panel.add( new JScrollPane( list ) );
		this.setSize( 150, 300 );
		this.setResizable( false );
		this.setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
	}
	
	public void setList( String[] servers ){
		list.setListData( servers );
	}
}