package velha;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.net.*;


/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

public class Convidar extends JDialog {
    JLabel jLabelConvJog = new JLabel();
    JButton jButtonConvidar = new JButton();
    JButton jButtonCancelar = new JButton();
    private String[] jog;// = {"eu","tu","Mi","Beto", "Pablo", "Everson", "Lino"};
    JComboBox jComboBoxJogadores ;//= new JComboBox(jog);

    private Jogador jogador = null;
//    private Jogador convidado = null;
    private String convidado = "";
    private boolean convite = false;
    private FramePrincipal principal;


    public Convidar(Frame frame, String title, boolean modal) {
        super(frame, title, modal);
        try {
            jbInit();
            pack();
        }
        catch(Exception ex) {
            ex.printStackTrace();
        }
    }

    public Convidar(FramePrincipal frame, Jogador j) {
//        super(frame, title, modal);
        principal = frame;
        try {
            this.jogador = j;
            jbInit();
            pack();
        }
        catch(Exception ex) {
            ex.printStackTrace();
        }
    }



    public void setConvidado() throws UnknownHostException {
      if ((String) this.jComboBoxJogadores.getSelectedItem() != null) {
//        this.convidado = (String) this.jComboBoxJogadores.getSelectedItem();
        this.convidado = (String) this.jComboBoxJogadores.getSelectedItem();
      }
      else {
        this.convidado = "Selecao nula";
      }
    }

    public String getConvidado(){
        return this.convidado;
    }

    public boolean getConvite(){
        return this.convite;
    }

    public Convidar() {
        this(null, "Status", false);
    }
    private void jbInit() throws Exception {
        if (this.principal != null){
            this.jog = new String [this.principal.JogadoresOnLine().length];
            this.jog = this.principal.JogadoresOnLine();
        }else{
            this.jog = new String[1];
            this.jog[0] = "jogador 1";
        }
        this.jComboBoxJogadores = new JComboBox(jog);
        jLabelConvJog.setFont(new java.awt.Font("Dialog", 1, 14));
        jLabelConvJog.setForeground(SystemColor.desktop);
        jLabelConvJog.setHorizontalAlignment(SwingConstants.CENTER);
        jLabelConvJog.setText("Convidar Jogador :");
        jLabelConvJog.setBounds(new Rectangle(98, 62, 177, 23));
        this.getContentPane().setBackground(Color.lightGray);
        this.getContentPane().setLayout(null);
        jComboBoxJogadores.setBounds(new Rectangle(97, 91, 181, 28));
        jButtonConvidar.setBounds(new Rectangle(75, 193, 96, 35));
        jButtonConvidar.setText("Convidar");
        jButtonConvidar.addActionListener(new Convidar_jButtonConvidar_actionAdapter(this));
        jButtonCancelar.setText("Cancelar");
        jButtonCancelar.addActionListener(new Convidar_jButtonCancelar_actionAdapter(this));
        jButtonCancelar.setBounds(new Rectangle(207, 193, 96, 35));
        this.getContentPane().add(jButtonCancelar, null);
        this.getContentPane().add(jButtonConvidar, null);
        this.getContentPane().add(jComboBoxJogadores, null);
        this.getContentPane().add(jLabelConvJog, null);
    }

    void jButtonConvidar_actionPerformed(ActionEvent e) throws UnknownHostException{
         this.setConvidado();
         Players j2 = principal.getJogadorLista(this.getConvidado());
         principal.convidar(j2.getNick());
         this.convite = true;

         //Requisitar jogo atravs do servidor
         //this.jogador.requisitarJogo();//Mandar p/ o servidor
         //O servidor manda uma requisiao de jogo p/ outro jogador
         if (this.principal != null){
             principal.setJogador2(principal.getJogadorLista(this.getConvidado()).getJogador());
         }else{
             principal.setJogador2(new Jogador("**Jogador 2**"));
         }

         this.dispose();

         if (this.principal != null){
           Jogo jogo = new Jogo(principal, this.principal.getJogador1(),
                                this.principal.getJogador2());

           jogo.setJog1(this.principal.getJogador1());
           jogo.setJog2(this.principal.getJogador2());
           jogo.setBounds(200, 70, 600, 600);
           jogo.show();
         }
         else{
           Jogo jogo = new Jogo(principal, new Jogador("Nulo"),
                                new Jogador("inexistente"));

           jogo.setJog1(new Jogador("Nulo"));
           jogo.setJog2(new Jogador("inexistente"));
           jogo.setBounds(200, 70, 600, 600);
           jogo.show();

         }
    }

    void jButtonCancelar_actionPerformed(ActionEvent e) {
        this.convite = false;
        this.dispose();
    }
}

class Convidar_jButtonConvidar_actionAdapter implements java.awt.event.ActionListener {
    Convidar adaptee;

    Convidar_jButtonConvidar_actionAdapter(Convidar adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
      try{
        adaptee.jButtonConvidar_actionPerformed(e);
      }catch(UnknownHostException ex){
        ex.printStackTrace();
      }
    }
}

class Convidar_jButtonCancelar_actionAdapter implements java.awt.event.ActionListener {
    Convidar adaptee;

    Convidar_jButtonCancelar_actionAdapter(Convidar adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonCancelar_actionPerformed(e);
    }
}
