package velha;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;
import java.net.UnknownHostException;
import java.rmi.*;
import java.util.Vector;
import java.util.Iterator;
import java.io.*;


/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

public class FramePrincipal extends JFrame {
 // JButton jButtonJogar = new JButton();
  JButton jButtonStatus = new JButton();
  JButton jButtonConvidar = new JButton();
  JButton jButtonSair = new JButton();
  JLabel jLabel1 = new JLabel();
  JLabel jLabel2 = new JLabel();

  String cliente;
  VelhaServer servidor;
  private Jogador jogador1;
  private Jogador jogador2;
//  String jogador = "";
 // String adversario = "";
  private ImageIcon fundo = new ImageIcon("velha_fundo.jpg");
  JList jListJogadores = new JList();


  public FramePrincipal()throws UnknownHostException {
    super ("Jogo da Velha");
    jogador1 = new Jogador("Jogador 1");
    jogador2 = new Jogador("Jogador 2");


   try {
  //   this.getContentPane().add(desktop);
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }

  }

  public FramePrincipal(String ip)throws UnknownHostException {
    super ("Jogo da Velha");
    jogador1 = new Jogador("Jogador 1");
    jogador2 = new Jogador("Jogador 2");
    cliente = ip;
   try {
  //   this.getContentPane().add(desktop);
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }

  }

  public void setServidor(VelhaServer velha){
    this.servidor = velha;
  }
  
  public Players getJogadorLista(String nome){
    Players retorno = null;
    boolean achou = false;
    try{
      Vector lista = this.servidor.getAllClients();
      Iterator it = lista.iterator();
      Players p = null;
      int i = 0;
      while (!achou || it.hasNext() ){
         p = (Players) it.next();
         if (p.getNick() != null && p.getNick().equals(nome)){
             achou = true;
             retorno = p;
         }
      }
    }catch(Exception ex){
        ex.printStackTrace();
    }
      return retorno;
  }

  public static void main(String[] args) throws UnknownHostException{
    try{

      String serv = JOptionPane.showInputDialog("Digite o servidor:");
      FramePrincipal framePrincipal = new FramePrincipal(serv);
      String end = "//"+serv+"/VelhaServer";
      VelhaServer temp = (VelhaServer) Naming.lookup(end);
      framePrincipal.setServidor(temp);
      //ThreadAtualizar atualizar = new ThreadAtualizar(framePrincipal);
      //atualizar.start();

      ThreadLista lista = new ThreadLista(framePrincipal);
      lista.start();

      framePrincipal.setVisible(true);

      Logar log = new Logar(framePrincipal);
      log.setBounds(280, 250, 410, 300);
      log.show();

      framePrincipal.addWindowListener(
            new WindowAdapter() {
        public void windowClosing(WindowEvent e) {
            System.exit(0);
        }
      });
    }
    catch(Exception e){
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception {

    this.getContentPane().setBackground(Color.lightGray);
    this.setSize(1024,768);
   // this.setIconImage(fundo);
    //jButtonJogar.setBounds(new Rectangle(149, 285, 138, 37));
    //jButtonJogar.setToolTipText("Jogar agora!! Sem escolha de adversrio.");
    //jButtonJogar.setText("Jogar");
      //  jButtonJogar.addActionListener(new FramePrincipal_jButtonJogar_actionAdapter(this));
    this.getContentPane().setLayout(null);
    jButtonStatus.setText("Status");
        jButtonStatus.addActionListener(new FramePrincipal_jButtonStatus_actionAdapter(this));
    jButtonStatus.setBounds(new Rectangle(149, 346, 138, 37));
    jButtonStatus.setToolTipText("Veja seus pontos");
    jButtonConvidar.setText("Convidar");
        jButtonConvidar.addActionListener(new FramePrincipal_jButtonConvidar_actionAdapter(this));
    jButtonConvidar.setBounds(new Rectangle(149, 405, 138, 37));
    jButtonConvidar.setToolTipText("Convida algum para jogar");
    jButtonSair.setText("Sair");
        jButtonSair.addActionListener(new FramePrincipal_jButtonSair_actionAdapter(this));
    jButtonSair.setBounds(new Rectangle(149, 455, 138, 37));
    jButtonSair.setToolTipText("Sair do Programa");
    jLabel1.setFont(new java.awt.Font("Dialog", 0, 14));
        jLabel1.setForeground(SystemColor.desktop);
    jLabel1.setHorizontalAlignment(SwingConstants.CENTER);
        jLabel1.setHorizontalTextPosition(SwingConstants.CENTER);
    jLabel1.setText("Jogadores on-line : ");
    jLabel1.setBounds(new Rectangle(600, 114, 155, 29));
    jLabel2.setFont(new java.awt.Font("SansSerif", 1, 40));
        jLabel2.setForeground(SystemColor.desktop);
        jLabel2.setVerifyInputWhenFocusTarget(true);
        jLabel2.setHorizontalAlignment(SwingConstants.CENTER);
        jLabel2.setText("Jogo da Velha");
        jLabel2.setBounds(new Rectangle(350, 26, 284, 68));
    jListJogadores.setFont(new java.awt.Font("Dialog", 0, 14));
    jListJogadores.setForeground(SystemColor.desktop);
    jListJogadores.setBounds(new Rectangle(553, 165, 262, 455));
    this.getContentPane().add(jLabel1, null);
        this.getContentPane().add(jButtonStatus, null);
        this.getContentPane().add(jButtonConvidar, null);
//        this.getContentPane().add(jButtonJogar, null);
        this.getContentPane().add(jButtonSair, null);
        this.getContentPane().add(jLabel2, null);
    this.getContentPane().add(jListJogadores, null);
    ConviteThread thread = new ConviteThread();
    thread.start();
  }


  public void ListaOnLine(){
    try{
      Vector lista = this.servidor.getAllClients();
      Iterator it = lista.iterator();
      String onlines = "";
      Players p = null;
      Vector jog = new Vector();
      while (it.hasNext()){
         p = (Players) it.next();
         //onlines = onlines + p.getNick() + "\n";
         jog.addElement(p.getNick());
      }
      this.jListJogadores.setListData(jog);

    }catch(Exception ex){

    }

  }

  public String[] JogadoresOnLine(){
    String[] jogadores = null;
    try{
      Vector lista = this.servidor.getAllClients();
      jogadores = new String[lista.size()];
      Iterator it = lista.iterator();
      String onlines = "";
      Players p = null;
  //    Vector jog = new Vector();
      int i = 0;
      while (it.hasNext()){
         p = (Players) it.next();
//         jog.addElement(p.getNick());
         if(!p.getNick().equals(this.jogador1.getNome())){
           jogadores[i] = p.getNick();
           i = i +1;
         }

      }
    //  jogadores =  jog.toArray()    ;
    }catch(Exception ex){
        ex.printStackTrace();
    }
    finally{
      return jogadores;
    }
  }

   public void convidar(String nick){
     try{
       this.servidor.convidarJog(this, nick);
     }
     catch(Exception e){
       e.printStackTrace();
     }
   }

   /**public boolean mostrarTela(FramePrincipal p){
     int ver = JOptionPane.showConfirmDialog(null, "Deseja iniciar um jogo com: "+ jogador1.getNome());
     if(ver == JOptionPane.NO_OPTION){
        return false;
     }
     else{
        return true;
     }
   }*/

   public void setJogador(String j1) throws UnknownHostException{
       if (j1!= null && j1!= ""){
           this.jogador1 = new Jogador(j1);
       }
   }

   public void setAdversario(String j2) throws UnknownHostException{
       if (j2 != null && j2 != ""){
           this.jogador2 = new Jogador(j2);
       }
   }

   public String getJogador(){
       return this.jogador1.getNome();
   }

   public String getAdversario(){
       return this.jogador2.getNome();
   }


   public Jogador getJogador1(){
       return this.jogador1;
   }

   public Jogador getJogador2(){
       return this.jogador2;
   }

   public void setJogador1(Jogador j){
       if (j != null){
           this.jogador1 = j;
       }
   }

   public void setJogador2(Jogador j){
       if (j != null){
           this.jogador2 = j;
       }
   }
   
   public void jogar(FramePrincipal f){

   }

    void jButtonConvidar_actionPerformed(ActionEvent e) {
        Convidar convJog = new Convidar(this,this.getJogador1());
        convJog.setBounds(280,200,400,350);
        convJog.show();
    }

    void jButtonStatus_actionPerformed(ActionEvent e) {
        StatusJogador status = new StatusJogador(this,this.getJogador1());
        status.setJogador(this.getJogador1());
        status.setBounds(280,200,440,380);
        status.show();
    }

    void jButtonSair_actionPerformed(ActionEvent e) {
        try{
          this.servidor.remove(jogador1);
        }
        catch(Exception f){
          f.printStackTrace();
        }
        System.exit(0);
    }

/*    void jButtonJogar_actionPerformed(ActionEvent e) {
try{      Jogo jogo = new Jogo(this,this.getJogador1(), this.getJogador2());
        jogo.setJog1(this.getJogador1());
        jogo.setJog2(this.getJogador2());
        jogo.setBounds(200, 70, 600, 600);
        jogo.show();
      }catch(Exception ex){

      }
    }*/
    
    private class ConviteThread extends Thread {

	private VelhaServer serv = FramePrincipal.this.servidor;
	private boolean keep;

	public ConviteThread( ){
		//position = pos;
		keep = true;
	}

	public void run(){
		/**while (keep){
			if (convites.get(i)!=null){
				temConvite																
			}
		}*/
		while(keep){
		  FramePrincipal temp = null;
                  try{
                    temp = serv.temConvite(FramePrincipal.this.getJogador1().getNome());
                  }
                  catch(Exception e){
                    //e.printStackTrace();
                  }
		  if (temp != null)
		  {
		    //jogar(temp);
		     try{
                       jogador1.aceitarJogo(temp.getJogador1());
                     }
                     catch(IOException g){

                     }
		  }
		}
	}

	public void destroy(){
		keep = false;
	}
}


}

/*class Painel extends JPanel{
     private ImageIcon fundo;

     public Painel(){
         fundo = new ImageIcon("velha_fundo.jpg");
     }

     public void paint (Graphics g){
         fundo.paintIcon(this,g,1024,768);
     }

     public Dimension getAlturaELargura(){
         return new Dimension(fundo.getIconWidth(),fundo.getIconHeight());
     }

}*/

class FramePrincipal_jButtonConvidar_actionAdapter implements java.awt.event.ActionListener {
    FramePrincipal adaptee;

    FramePrincipal_jButtonConvidar_actionAdapter(FramePrincipal adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonConvidar_actionPerformed(e);
    }
}

class FramePrincipal_jButtonStatus_actionAdapter implements java.awt.event.ActionListener {
    FramePrincipal adaptee;

    FramePrincipal_jButtonStatus_actionAdapter(FramePrincipal adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonStatus_actionPerformed(e);
    }
}

class FramePrincipal_jButtonSair_actionAdapter implements java.awt.event.ActionListener {
    FramePrincipal adaptee;

    FramePrincipal_jButtonSair_actionAdapter(FramePrincipal adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonSair_actionPerformed(e);
    }
}

/*class FramePrincipal_jButtonJogar_actionAdapter implements java.awt.event.ActionListener {
    FramePrincipal adaptee;

    FramePrincipal_jButtonJogar_actionAdapter(FramePrincipal adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonJogar_actionPerformed(e);
    }
} */
