package velha;
/**
 *	<b>Projeto:</b>    FARMAIS<br>
 *	<b>Classe:</b>     Servidor<br>
 *  <b>Extends:</b>    JDesktopPane
 *	<b>Funo:</b>     <br>
 *
 *	@author		   <>
 *
 */

import java.awt.*;
import javax.swing.*;

public class DesktopImagem extends JDesktopPane {

       private Image figura;

       public DesktopImagem (String arquivo) {
              super();
              figura = new ImageIcon(arquivo).getImage();
       }

       public void paint(Graphics imagem) {
              Rectangle r = imagem.getClipBounds();
              if (super.isOpaque()){
                 Color cor = getBackground();
                 if(cor == null)
                      cor = Color.lightGray;
                 imagem.setColor(cor);
                 imagem.fillRect(r.x, r.y, r.width, r.height);
              }
              imagem.drawImage(figura,0,0,null);
              super.paint(imagem);
       }

       public synchronized boolean isOpaque() {
              return false;
       }

}
