package velha;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;

public class ServerGUI extends JFrame {
	private JRadioButton radio[];
	private JTextField ip;
	private JButton ok;
	private JComboBox numClients;
		
	public ServerGUI(){
		super( "::.Servidor.::" );
		Container c = this.getContentPane();
		radio = new JRadioButton[ 2 ];
		radio[ 0 ] = new JRadioButton( "Conectar-se como servidor principal" );
		radio[ 0 ].setSelected( true );
		radio[ 1 ] = new JRadioButton( "Conectar-se como servidor dependente" );
		radio[ 1 ].addChangeListener( new ButtonListener( this ) );
		ip = new JTextField( 15 );
		ip.setEnabled( false );
		ok = new JButton( "  Conectar  " );
		ok.addActionListener( new ButtonListener( this ) );
		numClients = new JComboBox();
		for (int i = 1;i < 5 ;i++ ){
			numClients.addItem( "                                             " + i );
		}
		numClients.addActionListener( new ButtonListener( this ) );
		ButtonGroup group = new ButtonGroup();
		group.add( radio[ 0 ] );
		group.add( radio[ 1 ] );
		JPanel panel = new JPanel( new GridLayout( 2, 1 ) );
		JPanel ipPanel = new JPanel();
		ipPanel.setBorder( new TitledBorder( "Digite o ip do servidor principal:" ) );
		ipPanel.add( ip );
		JPanel cbPanel = new JPanel();
		cbPanel.setBorder( new TitledBorder( "Servidores dependentes" ) );
		cbPanel.add( numClients );
		panel.add( radio[ 0 ] );
		panel.add( radio[ 1 ] );
		c.setLayout( new FlowLayout() );
		c.add( panel );
		c.add( ipPanel );
		c.add( cbPanel );
		c.add( ok );		
		this.setSize( 380, 220 );
		this.setResizable( false );
		this.setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
		this.show();
	}
	
	public static void main( String args[] ){
		ServerGUI app = new ServerGUI();
	}
	
	private class ButtonListener implements ChangeListener, ActionListener {
		private JFrame frame;
		
		public ButtonListener( JFrame fram ){
			frame = fram;
		}
		
		public void stateChanged( ChangeEvent ce ){
//			Object source = ce.getSource();
//			if ( source.equals( radio[ 1 ] ) ){
				ip.setEnabled( radio[ 1 ].isSelected() );
//			}
		}

		public void actionPerformed( ActionEvent ae ){
			Object source = ae.getSource();
			if ( source.equals( ok ) ){
			        String temp = (String)numClients.getSelectedItem();
				int dependentes = Integer.parseInt( temp.charAt(temp.length() - 1) + "" );
				if ( radio[ 0 ].isSelected() ){

					Server server = new Server( null, dependentes );
					frame.setVisible( false );
					server.runServer();
				}
				else if ( radio[ 1 ].isSelected() ){
					frame.setVisible( false );
					Server server = new Server( ip.getText(), dependentes );
				}
			}
//			else if (source.equals( numClients ){
//				numClients.getSelectedItem().
//			}
		}
	}
}
