package velha;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

public class StatusJogador
    extends JDialog {
  JLabel jLabelVitorias = new JLabel();
  JLabel jLabelLogin = new JLabel();
  JTextField jTextFieldPontos = new JTextField();
  JButton Voltar = new JButton();
  JTextField jTextFieldEmpates = new JTextField();
  JLabel jLabelJogos = new JLabel();
  JLabel jLabelEmpates = new JLabel();
  JTextField jTextFieldPartidas = new JTextField();
  JTextField jTextFieldVitorias = new JTextField();
  JLabel jLabelPontos = new JLabel();
  JTextField jTextFieldLogin = new JTextField();

  private Jogador jogador;
  private FramePrincipal principal;

  public StatusJogador(Frame frame, boolean modal) {
    super(frame, "Status do Jogador", modal);
    try {
      jbInit();
      pack();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  public StatusJogador(FramePrincipal p, Jogador j) {
    this(null, false);
    this.principal = p;
    try {
      if (j != null){
          this.jogador = j;
      }else{
      jogador = new Jogador("jog 1");
      }
      jbInit();
      pack();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  public StatusJogador() {
    this(null, false);
  }

  public void setJogador(Jogador j) {
    if (j != null) {
      this.jogador = j;
    }
  }

  public Jogador getJogador(){
       return  this.jogador;
  }

  public String getJogadorNome() {
    return this.jogador.getNome();
  }

  private void jbInit() throws Exception {
    try{
      jTextFieldLogin.setBounds(new Rectangle(191, 78, 104, 24));
      jTextFieldLogin.setText(principal.getJogador());
      jTextFieldLogin.setEditable(false);
      jTextFieldLogin.setEnabled(false);
      jLabelPontos.setForeground(SystemColor.desktop);
      jLabelPontos.setVerifyInputWhenFocusTarget(true);
      jLabelPontos.setText("Pontos:");
      jLabelPontos.setBounds(new Rectangle(82, 105, 59, 22));
      jTextFieldVitorias.setEditable(false);

      //Nmero de Vitrias do Jogador
      if (this.jogador != null){
      jTextFieldVitorias.setText(this.jogador.getVitorias() + "");
      }else{
        jTextFieldVitorias.setText("0");
      }

      jTextFieldVitorias.setBounds(new Rectangle(191, 159, 104, 24));
      jTextFieldPartidas.setEditable(false);

      //Nmero de Partidas
      if (this.jogador != null){
      jTextFieldPartidas.setText(this.jogador.getJogos() + "");
      }else{
      jTextFieldPartidas.setText("0");
      }

      jTextFieldPartidas.setBounds(new Rectangle(191, 131, 104, 24));
      jLabelEmpates.setVerifyInputWhenFocusTarget(true);
      jLabelEmpates.setText("Empates:");
      jLabelEmpates.setBounds(new Rectangle(82, 185, 59, 22));
      jLabelJogos.setForeground(SystemColor.desktop);
      jLabelJogos.setVerifyInputWhenFocusTarget(true);
      jLabelJogos.setText("Total de Jogos:");
      jLabelJogos.setBounds(new Rectangle(82, 130, 85, 22));
      jTextFieldEmpates.setEditable(false);

      //Nmero de Empates
      if (this.jogador != null){
      jTextFieldEmpates.setText(this.jogador.getEmpates() + "");
      }else{
      jTextFieldEmpates.setText("0");
      }

      jTextFieldEmpates.setBounds(new Rectangle(191, 185, 104, 24));
      Voltar.addActionListener(new StatusJogador_Voltar_actionAdapter(this));
      Voltar.setText("Voltar");
      Voltar.setBounds(new Rectangle(142, 231, 104, 40));
      jTextFieldPontos.setEditable(false);

      //Nmero de Pontos j obtidos
      if (this.jogador != null){
      jTextFieldPontos.setText(this.jogador.getPontos() + "");
      }else{
      jTextFieldPontos.setText("0");
      }

      jTextFieldPontos.setBounds(new Rectangle(191, 105, 104, 24));
      jLabelLogin.setBounds(new Rectangle(82, 78, 59, 22));
      jLabelLogin.setText("Login:");
      jLabelLogin.setVerifyInputWhenFocusTarget(true);
      jLabelVitorias.setVerifyInputWhenFocusTarget(true);
      jLabelVitorias.setRequestFocusEnabled(true);
      jLabelVitorias.setForeground(SystemColor.desktop);
      jLabelVitorias.setPreferredSize(new Dimension(37, 15));
      jLabelVitorias.setText("Vitrias:");
      jLabelVitorias.setBounds(new Rectangle(82, 160, 59, 22));
      this.getContentPane().setBackground(Color.lightGray);
      this.getContentPane().setLayout(null);
      jLabelLogin.setForeground(SystemColor.desktop);
      jLabelLogin.setVerifyInputWhenFocusTarget(true);
      jLabelLogin.setText("Login :");
      jLabelLogin.setBounds(new Rectangle(82, 60, 59, 22));
      jTextFieldPontos.setBackground(Color.white);
      jTextFieldPontos.setEnabled(true);
      jTextFieldPontos.setDoubleBuffered(false);
      jTextFieldPontos.setEditable(false);
      jTextFieldPontos.setBounds(new Rectangle(201, 86, 104, 24));
      Voltar.setBounds(new Rectangle(152, 221, 104, 40));
      Voltar.setOpaque(true);
      Voltar.setText("OK");
      Voltar.addActionListener(new StatusJogador_Voltar_actionAdapter(this));
      jTextFieldEmpates.setBackground(Color.white);
      jTextFieldEmpates.setEditable(false);
      jTextFieldEmpates.setBounds(new Rectangle(201, 166, 104, 24));
      jLabelJogos.setText("Jogos Terminados :");
      jLabelJogos.setBounds(new Rectangle(82, 112, 108, 22));
      jLabelEmpates.setForeground(SystemColor.desktop);
      jLabelEmpates.setPreferredSize(new Dimension(47, 15));
      jLabelEmpates.setText("Empates :");
      jLabelEmpates.setBounds(new Rectangle(82, 167, 59, 22));
      jTextFieldPartidas.setBackground(Color.white);
      jTextFieldPartidas.setEnabled(true);
      jTextFieldPartidas.setEditable(false);
      jTextFieldPartidas.setBounds(new Rectangle(201, 112, 104, 24));
      jTextFieldVitorias.setBackground(Color.white);
      jTextFieldVitorias.setEnabled(true);
      jTextFieldVitorias.setEditable(false);
      jTextFieldVitorias.setBounds(new Rectangle(201, 140, 104, 24));
      jLabelPontos.setText("Pontos :");
      jLabelPontos.setBounds(new Rectangle(82, 87, 59, 22));
      jTextFieldLogin.setBackground(Color.white);
      jTextFieldLogin.setEnabled(true);
      jTextFieldLogin.setDoubleBuffered(false);

      //Login (Nome do Jogador)
      if (this.jogador != null){
      jTextFieldLogin.setToolTipText(this.jogador.getNome());
      }else{
      jTextFieldLogin.setToolTipText("Jogador desconhecido");
      }

      jTextFieldLogin.setCaretColor(Color.white);
      jTextFieldLogin.setDisabledTextColor(Color.black);
      jTextFieldLogin.setEditable(false);
      jTextFieldLogin.setBounds(new Rectangle(201, 59, 104, 24));
      jLabelVitorias.setText("Vitrias :");
      jLabelVitorias.setBounds(new Rectangle(82, 142, 59, 22));
      this.getContentPane().add(jTextFieldPartidas, null);
      this.getContentPane().add(jTextFieldPontos, null);
      this.getContentPane().add(jTextFieldEmpates, null);
      this.getContentPane().add(jTextFieldVitorias, null);
      this.getContentPane().add(jTextFieldLogin, null);
      this.getContentPane().add(Voltar, null);
      this.getContentPane().add(jLabelJogos, null);
      this.getContentPane().add(jLabelLogin, null);
      this.getContentPane().add(jLabelPontos, null);
      this.getContentPane().add(jLabelVitorias, null);
      this.getContentPane().add(jLabelEmpates, null);
    }
    catch(NullPointerException ex){

    }catch(Exception e){

    }

  }


  void Voltar_actionPerformed(ActionEvent e) {
    this.dispose();
  }
}

class StatusJogador_Voltar_actionAdapter
    implements java.awt.event.ActionListener {
  StatusJogador adaptee;

  StatusJogador_Voltar_actionAdapter(StatusJogador adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.Voltar_actionPerformed(e);
  }
}