package velha;

import java.rmi.*;
import java.net.*;
/**
 * Universidade Federal de Pernambuco
 * Centro de Informtica
 * Disciplina: Infra-Estrutura de Software
 * Projeto: Jogo da Velha
 *
 * Tipo:     ThreadUpdate
 * Alunos: Everson Luis da Silva Melo (elsm2@cin.ufpe.br)
 *         Lamberto Augusto de Oliveira Neto (laon@cin.ufpe.br)
 *         Millena de Andrade Almeida Gomes (maag@cin.ufpe.br)
 *         Pablo Arajo Borges (pab@cin.ufpe.br)
 */

 public class ThreadUpdate extends Thread{

    private VelhaServerImpl servidor;

    public ThreadUpdate(VelhaServerImpl server){
      if(server != null){
        servidor = server;
      }
    }

    public void run(){
      try{
        while(true){
          servidor = (VelhaServerImpl)servidor.clone();
          servidor.update();
        }
      }
      catch(RemoteException e){
        e.printStackTrace();
      }
      catch(MalformedURLException f){
        f.printStackTrace();
      }
      catch(Exception g){
        g.printStackTrace();
      }

    }
 }