package velha;

import java.rmi.*;
import java.net.*;
import java.util.Vector;

/**
 * Universidade Federal de Pernambuco
 * Centro de Informtica
 * Disciplina: Infra-Estrutura de Software
 * Projeto: Jogo da Velha
 *
 * Tipo:     VelhaServer
 * Alunos: Everson Luis da Silva Melo (elsm2@cin.ufpe.br)
 *         Lamberto Augusto de Oliveira Neto (laon@cin.ufpe.br)
 *         Millena de Andrade Almeida Gomes (maag@cin.ufpe.br)
 *         Pablo Arajo Borges (pab@cin.ufpe.br)
 */

 public interface VelhaServer extends Remote{

       public String getClient() throws RemoteException;//, NotBoundException, MalformedURLException;

       public boolean hasClient() throws RemoteException;//, NotBoundException, MalformedURLException;

       public void insertion(Players novo) throws RemoteException;

       public Vector getAllClients() throws RemoteException;//, NotBoundException, MalformedURLException;

       public void remove(Jogador jog) throws RemoteException;

       public void remove(String jog) throws RemoteException;

       public boolean convidarJog(FramePrincipal p, String convidado) throws RemoteException;
       
       public FramePrincipal temConvite(String nick) throws RemoteException;
 }
